=== modified file 'INSTALL'
--- INSTALL	2014-07-25 22:44:20 +0000
+++ INSTALL	2013-06-23 15:13:06 +0000
@@ -4,15 +4,14 @@
   
 ** Operating System
    
-   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat" (or later).
+   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat".
    
    This is mostly for the support scripts which make sure that the
    client is installed and started in the initial RAM disk environment
-   and that the initial RAM file system image file is automatically
-   made unreadable.  The server and client programs themselves *could*
-   be run in other distributions, but they *are* specific to GNU/Linux
-   systems, and are not written with portabillity to other Unixes in
-   mind.
+   and that the initrd.img file is automatically made unreadable.  The
+   server and client programs themselves *could* be run in other
+   distributions, but they *are* specific to GNU/Linux systems, and
+   are not written with portabillity to other Unixes in mind.
    
 ** Libraries
    
@@ -28,7 +27,7 @@
     + DocBook 4.5         http://www.docbook.org/
       Note: DocBook 5.0 is not compatible.
     + DocBook XSL stylesheets 1.71.0
-                         http://wiki.docbook.org/DocBookXslStylesheets
+                   http://wiki.docbook.org/topic/DocBookXslStylesheets
     
     Package names:
     docbook docbook-xsl
@@ -38,40 +37,32 @@
     "man -l mandos.8".
     
 *** Mandos Server
-    + GnuTLS 2.4          http://www.gnutls.org/
-      Note: GnuTLS 3 will only work with Python-GnuTLS 2
+    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
     + Avahi 0.6.16        http://www.avahi.org/
-    + Python 2.7          https://www.python.org/
-    + Python-GnuTLS 1.1.5 https://pypi.python.org/pypi/python-gnutls/
+    + Python 2.6          http://www.python.org/
+    + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
     + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
-    + PyGObject 2.14.2    https://developer.gnome.org/pygobject/
-    + pkg-config  http://www.freedesktop.org/wiki/Software/pkg-config/
-    + Urwid 1.0.1         http://urwid.org/
-      (Only needed by the "mandos-monitor" tool.)
+    + PyGObject 2.14.2    http://library.gnome.org/devel/pygobject/
+    + Urwid 0.9.8.3       http://excess.org/urwid/
     
     Strongly recommended:
-    + fping 2.4b2-to-ipv6      http://www.fping.org/
-    + ssh-keyscan from OpenSSH http://www.openssh.com/
+    + fping 2.4b2-to-ipv6 http://www.fping.com/
     
     Package names:
     python-gnutls avahi-daemon python python-avahi python-dbus
-    python-gobject python-urwid pkg-config fping ssh-client
+    python-gobject python-urwid
     
 *** Mandos Client
     + initramfs-tools 0.85i
-                        https://tracker.debian.org/pkg/initramfs-tools
-    + GnuTLS 2.4        http://www.gnutls.org/
-    + Avahi 0.6.16      http://www.avahi.org/
-    + GnuPG 1.4.9       https://www.gnupg.org/
-    + GPGME 1.1.6       https://www.gnupg.org/related_software/gpgme/
-    + pkg-config  http://www.freedesktop.org/wiki/Software/pkg-config/
-    
-    Strongly recommended:
-    + OpenSSH           http://www.openssh.com/
+                  http://packages.qa.debian.org/i/initramfs-tools.html
+    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
+    + Avahi 0.6.16        http://www.avahi.org/
+    + GnuPG 1.4.9         http://www.gnupg.org/
+    + GPGME 1.1.6         http://www.gnupg.org/related_software/gpgme/
     
     Package names:
     initramfs-tools libgnutls-dev libavahi-core-dev gnupg
-    libgpgme11-dev pkg-config ssh
+    libgpgme11-dev
 
 * Installing the Mandos server
   
@@ -107,11 +98,15 @@
      and append this to the file "/etc/mandos/clients.conf" *on the
      server computer*.
   
-  4. Configure the client to use any special configuration needed for
-     your local system.  Note: This is not necessary if the server is
-     present on the same wired local network as the client.  If you do
-     make changes to /etc/mandos/plugin-runner.conf, the initrd.img
-     file must be updated, possibly using the following command:
+  4. Configure the client to use the correct network interface.  The
+     interface to use is automatically chosen at boot, and if this
+     needs to be adjusted, it will be necessary to edit
+     /etc/initramfs-tools/initramfs.conf to change the DEVICE setting
+     there.  Alternatively, the file /etc/mandos/plugin-runner.conf
+     can be edited to add a "--device" parameter for the
+     mandos-client(8) plugin.  Please note: If any of those files are
+     changed, the initrd.img file must be updated, possibly using the
+     following command:
      
 	# update-initramfs -k all -u
   
@@ -131,14 +126,12 @@
      
      After this, the client computer should be able to reboot without
      needing a password entered on the console, as long as it does not
-     take more than five minutes to reboot.
+     take more than an hour to reboot.
 
 * Further customizations
   
   You may want to tighten or loosen the timeouts in the server
   configuration files; see mandos.conf(5) and mandos-clients.conf(5).
-  If IPsec is not used and SSH is not installed, it is suggested that
-  a more cryptographically secure checker program is used and
-  configured, since, without IPsec, ping packets can be faked.
-
-#+STARTUP: showall
+  If IPsec is not used, it is suggested that a more cryptographically
+  secure checker program is used and configured, since without IPsec
+  ping packets can be faked.

=== modified file 'Makefile'
--- Makefile	2014-07-17 03:24:57 +0000
+++ Makefile	2014-03-23 19:24:40 +0000
@@ -26,7 +26,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.6.7
+version=1.6.4
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -85,10 +85,13 @@
 	--param man.authors.section.enabled	0 \
 	/usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
+	$(MANPOST) $(notdir $@);\
 	if locale --all 2>/dev/null | grep --regexp='^en_US\.utf8$$' \
 	&& type man 2>/dev/null; then LANG=en_US.UTF-8 MANWIDTH=80 \
 	man --warnings --encoding=UTF-8 --local-file $(notdir $@); \
 	fi >/dev/null)
+# DocBook-to-man post-processing to fix a '\n' escape bug
+MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 
 DOCBOOKTOHTML=$(strip xsltproc --nonet --xinclude \
 	--param make.year.ranges		1 \
@@ -264,18 +267,15 @@
 	@echo "# ignored.  The messages are caused by not running as root, but   #"
 	@echo "# you should NOT run \"make run-client\" as root unless you also    #"
 	@echo "# unpacked and compiled Mandos as root, which is NOT recommended. #"
-	@echo "# From plugin-runner: setgid: Operation not permitted             #"
-	@echo "#                     setuid: Operation not permitted             #"
+	@echo "# From plugin-runner: setuid: Operation not permitted             #"
 	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
-	@echo "# From mandos-client:                                             #"
-	@echo "#             Failed to raise privileges: Operation not permitted #"
-	@echo "#             Warning: network hook \"*\" exited with status *      #"
+	@echo "# From mandos-client: setuid: Operation not permitted             #"
+	@echo "#                     seteuid: Operation not permitted            #"
+	@echo "#                     klogctl: Operation not permitted            #"
 	@echo "###################################################################"
-# We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
 	./plugin-runner --plugin-dir=plugins.d \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
-		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
 		$(CLIENTARGS)
 
 # Used by run-client
@@ -296,7 +296,7 @@
 	install --directory confdir
 	install --mode=u=rw $< $@
 # Add a client password
-	./mandos-keygen --dir keydir --password --no-ssh >> $@
+	./mandos-keygen --dir keydir --password >> $@
 statedir:
 	install --directory statedir
 

=== modified file 'NEWS'
--- NEWS	2014-07-17 03:24:57 +0000
+++ NEWS	2014-02-16 13:12:20 +0000
@@ -1,32 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.6.7 (2014-07-17)
-* Client
-** Bug fix: Now compatible with GPGME 1.5.0.
-** Bug fix: Fixed minor memory leaks.
-* Server
-** "mandos-monitor" now has verbose logging, toggleable with "v".
-
-Version 1.6.6 (2014-07-13)
-* Client
-** If client host has an SSH server, "mandos-keygen --password" now
-   outputs "checker" option which uses "ssh-keyscan"; this is more
-   secure than the default "fping" checker.
-** Bug fix: allow "." in network hook names, to match documentation.
-** Better error messages.
-* Server
-** New --no-zeroconf option.
-** Bug fix: Fix --servicename option, broken since 1.6.4.
-** Bug fix: Fix --socket option work for --socket=0.
-
-Version 1.6.5 (2014-05-11)
-* Client
-** Work around bug in GnuPG <http://bugs.g10code.com/gnupg/issue1622>
-** Give better error messages when run without sufficient privileges
-** Only warn if workaround for Debian bug #633582 was necessary and
-   failed, not if it failed and was unnecessary.
-
 Version 1.6.4 (2014-02-16)
 * Server
 ** Very minor fix to self-test code.

=== modified file 'TODO'
--- TODO	2014-07-14 21:41:08 +0000
+++ TODO	2014-03-23 22:12:57 +0000
@@ -44,8 +44,10 @@
 * plugin-runner
 ** TODO handle printing for errors for plugins
 *** Hook up stderr of plugins, buffer them, and prepend "Mandos Plugin [plugin name]"
+** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#C] use same file name rules as run-parts(8)
 ** kernel command line option for debug info
+** TODO [#C] Use fnmatch() to look for bad prefixes and suffixes
 
 * mandos (server)
 ** TODO [#B] Log level							  :BUGS:
@@ -81,11 +83,7 @@
    http://standards.freedesktop.org/secret-service/
 ** TODO Remove D-Bus interfaces with old domain name			  :2:
 ** TODO Remove old string_to_delta format				  :2:
-** TODO http://0pointer.de/blog/projects/stateless.html
-*** tmpfiles snippet to create /var/lib/mandos with right user+perms
-*** File in /usr/lib/sysusers.d to create user+group "_mandos"
-** TODO Error handling on error parsing config files
-** TODO init.d script error handling
+** TODO --no-zeroconf (only valid if port or socket is set)
 
 * mandos.xml
 ** Add mandos contact info in manual pages

=== modified file 'common.ent'
--- common.ent	2014-07-17 03:24:57 +0000
+++ common.ent	2014-02-16 13:12:20 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.6.7">
+<!ENTITY version "1.6.4">

=== modified file 'debian/changelog'
--- debian/changelog	2014-07-17 03:24:57 +0000
+++ debian/changelog	2014-02-16 13:12:20 +0000
@@ -1,47 +1,3 @@
-mandos (1.6.7-1) unstable; urgency=medium
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Thu, 17 Jul 2014 05:22:45 +0200
-
-mandos (1.6.6-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/mandos.postinst: Fix typo in comment.
-  * debian/control (mandos/Recommends): Changed to "ssh-client | fping".
-    (mandos-client/Recommends): New; set to "ssh".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 13 Jul 2014 22:49:21 +0200
-
-mandos (1.6.5-3) unstable; urgency=medium
-
-  * debian/control (mandos-client/Depends): Add "dpkg-dev (>=1.16.0)";
-    initramfs-tools-hook runs "dpkg-architecture -qDEB_HOST_MULTIARCH".
-    (Closes: #750221)
-
- -- Teddy Hogeborn <teddy@recompile.se>  Fri, 06 Jun 2014 04:27:15 +0200
-
-mandos (1.6.5-2) unstable; urgency=medium
-
-  * debian/rules (override_dh_auto_test-arch): New; does nothing.  Fixes
-    FTBFS for build-indep.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Tue, 13 May 2014 08:08:31 +0200
-
-mandos (1.6.5-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/copyright: Change year to "2014".
-  * debian/control (Build-Depends, Build-Depends-Indep): Moved build
-    dependencies of "mandos" package to "Build-Depends-Indep".
-  * debian/upstream/signing-key.asc: New; upstream source public key.
-  * debian/control (Standards-Version): Updated to "3.9.5".
-  * debian/control (mandos/Depends): Remove the dependency on
-    "avahi-daemon (>= 0.6.31-3) | systemd-sysv".  It is unnecessary
-    since we have a workaround in debian/mandos.postinst anyway.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 11 May 2014 22:16:33 +0200
-
 mandos (1.6.4-1) unstable; urgency=medium
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2014-07-25 22:44:20 +0000
+++ debian/control	2014-03-01 10:59:22 +0000
@@ -7,8 +7,9 @@
 Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
 	pkg-config
-Build-Depends-Indep: systemd, python2.7, python2.7-gnutls,
-	python2.7-dbus, python2.7-avahi, python2.7-gobject
+Build-Depends-Indep: systemd, python (>=2.6), python-gnutls,
+	python-dbus, python-avahi, python-gobject,
+	python (>=2.7) | python-argparse
 Standards-Version: 3.9.5
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
@@ -16,12 +17,12 @@
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (<= 2.7), python2.7, python-gnutls,
-	python2.7-gnutls, python-dbus, python2.7-dbus, python-avahi,
-	python2.7-avahi, python-gobject, python2.7-gobject,
-	avahi-daemon, adduser, python-urwid, python2.7-urwid,
-	gnupg (<< 2), initscripts (>= 2.88dsf-13.3)
-Recommends: ssh-client | fping
+Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
+	python-avahi, python-gobject, avahi-daemon, adduser,
+	python-urwid, python (>=2.7) | python-argparse, gnupg (<< 2),
+	initscripts (>= 2.88dsf-13.3), avahi-daemon (>= 0.6.31-3)
+	| systemd-sysv
+Recommends: fping
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
  computers to have encrypted root file systems and at the
@@ -40,8 +41,7 @@
 Package: mandos-client
 Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
-	gnupg (<< 2), initramfs-tools, dpkg-dev (>=1.16.0)
-Recommends: ssh
+	gnupg (<< 2), initramfs-tools
 Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2014-06-07 20:29:36 +0000
+++ debian/mandos.postinst	2014-01-06 17:22:30 +0000
@@ -51,7 +51,7 @@
 # "avahi-daemon") in its /etc/init.d script header.  To make
 # insserv(8) happy, we edit our /etc/init.d script header to contain
 # the correct string before the code added by dh_installinit calls
-# update.rc-d, which calls insserv.
+# update.rd-c, which calls insserv.
 avahi_version="`dpkg-query --showformat='${Version}' --show avahi-daemon`"
 if dpkg --compare-versions "$avahi_version" le 0.6.31-2; then
     sed --in-place --expression='/^### BEGIN INIT INFO$/,/^### END INIT INFO$/s/^\(# Required-\(Stop\|Start\):.*avahi\)-daemon\>/\1/g' /etc/init.d/mandos

=== modified file 'debian/rules'
--- debian/rules	2014-05-12 21:02:38 +0000
+++ debian/rules	2014-01-20 21:50:11 +0000
@@ -27,5 +27,3 @@
 		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
 	chmod --recursive g-w -- \
 	"$(CURDIR)/debian/mandos-client/usr/share/doc/mandos-client/examples/network-hooks.d"
-
-override_dh_auto_test-arch: ;

=== removed directory 'debian/upstream'
=== added file 'debian/upstream-signing-key.pgp'
Binary files debian/upstream-signing-key.pgp and debian/upstream-signing-key.pgp differ
=== removed file 'debian/upstream/signing-key.asc'
--- debian/upstream/signing-key.asc	2014-03-28 22:32:21 +0000
+++ debian/upstream/signing-key.asc	1970-01-01 00:00:00 +0000
@@ -1,52 +0,0 @@
------BEGIN PGP PUBLIC KEY BLOCK-----
-Version: GnuPG v1.4.12 (GNU/Linux)
-
-mQINBFJQOFYBEACoWsEGlOxVWFUAxOxdd3GDLaqEKkKihJwLp102Ks7JKMd9friR
-7+OZuo3U0gdqLU9q1jPJn36J1QbaUTOvcaKtZp+QpUoYJ2OaGtlOY5ML8LSoC0rZ
-MIzGYTtvriwpU/YplLNGPl/90KsB2VqjrY1l1he5M8zziWDlPdJxwg8GFvmPWoif
-6oo+1iCswL5IdQ6c5MVO53zYu0cgyUSazLsVD5Xzy59lefgtaDydahJpPycf5aEQ
-DAoC9fZt2mgG3FLIUCZdXIhZdOJGCMdjLThBnJXYgGbG4rbGLNlI4W/uA5aqa4ME
-WYSAcCyX3ucKY/LkXRtC+z5s05e7tZ3Z+uAJy1eDsbhDXgZERye7a/zPWx1tAlzQ
-E80Oltjh1uXWjQORyx99a0jK87zjm49YjhYw1ZN6Z0HfSaws4Yj2QOzp9t4B3l7f
-DIUYoWBfHW7mseQeQ+t3TwQU5gjFCNu7oDeATqi5A5MksXN0+BcksterbGRBhEyp
-CybIEyrZE033jIs407Ool4Kv10cnjc8oy609BXex/dxwcvVr2vQHle4NPUZd+Xhg
-zC+9Z4jFwE0M/EPvtyieA/DWQse+TZ5itDGMYDub/GJfv1U61ANOgPIbTEF7iSa9
-5nWmq7zyUy/txmABka842Kt0Vp6ayoKcF8EIXCaDrVfPnXj+JlKf3c2u6wARAQAB
-tCxNYW5kb3MgTWFpbnRhaW5lciBUZWFtIDxtYW5kb3NAcmVjb21waWxlLnNlPokC
-PQQTAQgAJwUCUlA4VgIbAwUJCWYBgAULCQgHAwUVCgkICwUWAgMBAAIeAQIXgAAK
-CRByIylzyjTCxETXEACi56jCV9lJNSBbTp0Iet4X/i7Mx0Z8UkFFa3l7o0i4jFQj
-CIBrWECDlcxqZziii2dgh7L0ma93vB3rfjfCWeYLcEQw43MFBsd4dHuobrLXTcqU
-7n0Zmc8BsXwk5B25CnEYgvlbWX9BCYtxHGRcZzQrqOFjCMKatq0EIIVuWaz5yuCU
-V2rEgnr+veTd/rBOE9ez6Ju6xH11Teob5G7pMM0YPKHtZG/J3rvWPw4BDM6Tc60B
-G0sTDZNgkrGWxuB8YaLIwVWzliQK/17Jv/0alajyA3cWLWMkcK9Yhi/einzdMRoD
-IjnbtoHcSC9g6i0VGelwnMpHlFTwXriXEBSttULarK3iKE4tOv9nxMAEwicqlw14
-X96PPgz6ogtJG7FiwZfy1CQ81Uby+YuIhHZx3ZEyR1TFq70e98EgCuvjMZWMIhSy
-gB5Vssfq7c2lXQjltV3ujhK1PD+7/iHlL7t4QRxPDN8fbMS2VPfAdtnWS1K48d5J
-D/jP1LrGWS81HIaX8GFVLVw+jSQEu9cn3TFiZxK/4MMsITmlouJdtZWmQ/otMSMl
-wiCCZp3dGpRXMmaqR1N8V0nMKshM8mci7bD92ubd/t6cR/G6l+VIp45WyFONvtde
-F3ccfmfrKJuroMDfHxPxMf58EroAuWwzJKCPRH4JmwDvSSQoIIAGNL1lOKp6wrkC
-DQRSUDhWARAAzN7pbpAu7XLNPODotV/N+JaCFvNAIqTcr9PrbhxiKFCDs9/IExwP
-sGENL9GZd1DfoGEgxQ8j3l8VGw9VSeUoN7uMY2NwwbXTilAFkn/S8xnr2zQDRZ+n
-EeFSq9MMFxj4Kt1TqVYDbO8vmFfOT3gRCRHeJ+pn4yJeSPau/ndNrmbQ1/Z6vaUG
-yfo931ottx7SXZwkHA6jJVFT9rbHTyx9tzOqMKDJiMrx8qKaHpE9B45oHNR0WJJJ
-75zoDVuOZ6wAxXZuqBFu2lKPqDTZeawfzcu5qplrm1RPgSOjz6w1A41HBLqGe+v9
-7Twx5wfNMgnKC0V2wUe0xR6hQHQlyZoCwcGyrasiu+v/joZ1p66SSWKjs+LGjoe4
-Lwh6VjZU2x+irVBjcgIoRWf3k4JAef0nGYsm0cFjAnwXac+/CYxVt+7Y4+HG8wPB
-oUNZkW+bvdHQouxEClxnccIEgX/AkriJTYDQ4q3tkl2HVE/51R4pdQVLer2a5ov+
-Jwk44DdqzYstMsvqu+iD48hXzADg6HFvofkpct15h463pMaJf99uVVM9ZDNQ6B34
-l3tPX9ZDkIDl6n9dE2Jkaxx1yNVhPXpeMf4EzL+CEdUErVStB66lUkw+tNkuZyVT
-ZTQel9h0196+CNSiqAaL8+ZZdbjKKfzlcB4Qnd897XzMfsFQ7mzJ9QsAEQEAAYkC
-JQQYAQgADwUCUlA4VgIbDAUJCWYBgAAKCRByIylzyjTCxFmlEACBTOg5NqX63d8D
-mwk4smlFPppQBIduxZaMG9HsLcPi3VKTG9Zg6WI6rEdr/4MnoINsudLsEbrQLgRH
-2q1Zs+HqIIP5H2/sYHmswyokYB10zKB6gNUUg/GSlcAcrelsHVKx5B8kccWGT5gk
-Wo/X0BGMUTOvQ6lJ6YNo1idcQ2ZjsyfZoz3G8JS7/EXN//jAZf+017yj8WsAS7hw
-JRFMy7VET4g00JcBoNOAMP7PkozimZ2OwwsggJSYWkR1RaU2tKR1VmDF8R6UxuEd
-BJzwFmz+wNC1Kq+FoSaRNsrKEmzLnfV9unDnF2z7Lc4LqOysXdzOk9zTBPur0gd2
-Lh5H/g5rTAMQBARqXfvIwiTtrBGgil8JW8e4Bc0LQUuHAE7x9gMRil+OtkQrCRk9
-0LWXVS+K0tvvruE4EDtCGiS5046+BEI3aYsp4hNzjHADq0TJeCYjNg9kY0CjxcEq
-cfuMoUbQ0MkARGuBbykCdlylfTrkxrj/dPhr49lctY3H+Pj6F4fMDM4TP6UTGA8k
-993RRNYhkDWSxIp6G7RJpBZobHN+eHQ3r8A4tWdYb4Fvd2lvwEDjUFT9uD6WAff4
-8A1hM2uSy91UYBOPrIjqYdRFKJc9rThYdXH2T6SiRMYtZMrEKhqPffB/i9mqVBlD
-6vKRsaQikZujRdP9Dkf0mLmJ7LANWw==
-=9Noe
------END PGP PUBLIC KEY BLOCK-----

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2014-07-16 23:44:54 +0000
+++ initramfs-tools-hook	2013-10-28 08:38:47 +0000
@@ -150,17 +150,11 @@
 done
 
 # GPGME needs GnuPG
-gpg=/usr/bin/gpg
 libgpgme11_version="`dpkg-query --showformat='${Version}' --show libgpgme11`"
-if dpkg --compare-versions "$libgpgme11_version" ge 1.5.0-0.1; then
-    if [ -e /usr/bin/gpgconf ]; then
-	if [ ! -e "${DESTDIR}/usr/bin/gpgconf" ]; then
-	    copy_exec /usr/bin/gpgconf
-	fi
-	gpg="`/usr/bin/gpgconf|sed --quiet --expression='s/^gpg:[^:]*://p'`"
-    fi
-elif dpkg --compare-versions "$libgpgme11_version" ge 1.4.1-0.1; then
+if dpkg --compare-versions "$libgpgme11_version" ge 1.4.1-0.1; then
     gpg=/usr/bin/gpg2
+else
+    gpg=/usr/bin/gpg
 fi
 if [ ! -e "${DESTDIR}$gpg" ]; then
     copy_exec "$gpg"

=== modified file 'intro.xml'
--- intro.xml	2014-06-22 02:19:30 +0000
+++ intro.xml	2011-12-31 23:05:34 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -215,22 +215,17 @@
       </para>
     </refsect2>
     
-    <refsect2 id="fakecheck">
-      <title>Faking checker results?</title>
+    <refsect2 id="fakeping">
+      <title>Faking ping replies?</title>
       <para>
-	If the Mandos client does not have an SSH server, the default
-	is for the Mandos server to use
+	The default for the server is to use
 	<quote><literal>fping</literal></quote>, the replies to which
 	could be faked to eliminate the timeout.  But this could
 	easily be changed to any shell command, with any security
-	measures you like.  If the Mandos client
-	<emphasis>has</emphasis> an SSH server, the default
-	configuration (as generated by
-	<command>mandos-keygen</command> with the
-	<option>--password</option> option) is for the Mandos server
-	to use an <command>ssh-keyscan</command> command with strict
-	keychecking, which can not be faked.  Alternatively, IPsec
-	could be used for the ping packets, making them secure.
+	measures you like.  It could, for instance, be changed to an
+	SSH command with strict keychecking, which could not be faked.
+	Or IPsec could be used for the ping packets, making them
+	secure.
       </para>
     </refsect2>
   </refsect1>

=== modified file 'mandos'
--- mandos	2014-07-25 23:16:04 +0000
+++ mandos	2014-02-22 17:13:00 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/python2.7
+#!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
 # 
 # Mandos server - give out binary blobs to connecting clients.
@@ -88,7 +88,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-version = "1.6.7"
+version = "1.6.4"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -114,7 +114,6 @@
 def initlogger(debug, level=logging.WARNING):
     """init logger and add loglevel"""
     
-    global syslogger
     syslogger = (logging.handlers.SysLogHandler
                  (facility =
                   logging.handlers.SysLogHandler.LOG_DAEMON,
@@ -536,7 +535,7 @@
             server_settings = {}
         self.server_settings = server_settings
         # adding all client settings
-        for setting, value in settings.items():
+        for setting, value in settings.iteritems():
             setattr(self, setting, value)
         
         if self.enabled:
@@ -707,10 +706,10 @@
         # Start a new checker if needed
         if self.checker is None:
             # Escape attributes for the shell
-            escaped_attrs = { attr:
-                                  re.escape(unicode(getattr(self,
-                                                            attr)))
-                              for attr in self.runtime_expansions }
+            escaped_attrs = dict(
+                (attr, re.escape(unicode(getattr(self, attr))))
+                for attr in
+                self.runtime_expansions)
             try:
                 command = self.checker_command % escaped_attrs
             except TypeError as error:
@@ -1009,7 +1008,7 @@
                                               (prop,
                                                "_dbus_annotations",
                                                {}))
-                        for name, value in annots.items():
+                        for name, value in annots.iteritems():
                             ann_tag = document.createElement(
                                 "annotation")
                             ann_tag.setAttribute("name", name)
@@ -1018,11 +1017,11 @@
                 # Add interface annotation tags
                 for annotation, value in dict(
                     itertools.chain.from_iterable(
-                        annotations().items()
+                        annotations().iteritems()
                         for name, annotations in
                         self._get_all_dbus_things("interface")
                         if name == if_tag.getAttribute("name")
-                        )).items():
+                        )).iteritems():
                     ann_tag = document.createElement("annotation")
                     ann_tag.setAttribute("name", annotation)
                     ann_tag.setAttribute("value", value)
@@ -1084,7 +1083,7 @@
     """
     def wrapper(cls):
         for orig_interface_name, alt_interface_name in (
-            alt_interface_names.items()):
+            alt_interface_names.iteritems()):
             attr = {}
             interface_names = set()
             # Go though all attributes of the class
@@ -2188,11 +2187,11 @@
     token_duration = Token(re.compile(r"P"), None,
                            frozenset((token_year, token_month,
                                       token_day, token_time,
-                                      token_week)))
+                                      token_week))),
     # Define starting values
     value = datetime.timedelta() # Value so far
     found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
+    followers = frozenset(token_duration,) # Following valid tokens
     s = duration                # String left to parse
     # Loop until end token is found
     while found_token is not token_end:
@@ -2337,9 +2336,6 @@
                         help="Directory to save/restore state in")
     parser.add_argument("--foreground", action="store_true",
                         help="Run in foreground", default=None)
-    parser.add_argument("--no-zeroconf", action="store_false",
-                        dest="zeroconf", help="Do not use Zeroconf",
-                        default=None)
     
     options = parser.parse_args()
     
@@ -2363,7 +2359,6 @@
                         "socket": "",
                         "statedir": "/var/lib/mandos",
                         "foreground": "False",
-                        "zeroconf": "True",
                         }
     
     # Parse config file for server-global settings
@@ -2396,7 +2391,7 @@
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
                    "use_dbus", "use_ipv6", "debuglevel", "restore",
-                   "statedir", "socket", "foreground", "zeroconf"):
+                   "statedir", "socket", "foreground"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2407,7 +2402,7 @@
             server_settings[option] = unicode(server_settings[option])
     # Force all boolean options to be boolean
     for option in ("debug", "use_dbus", "use_ipv6", "restore",
-                   "foreground", "zeroconf"):
+                   "foreground"):
         server_settings[option] = bool(server_settings[option])
     # Debug implies foreground
     if server_settings["debug"]:
@@ -2416,12 +2411,6 @@
     
     ##################################################################
     
-    if (not server_settings["zeroconf"] and
-        not (server_settings["port"]
-             or server_settings["socket"] != "")):
-            parser.error("Needs port or socket to work without"
-                         " Zeroconf")
-    
     # For convenience
     debug = server_settings["debug"]
     debuglevel = server_settings["debuglevel"]
@@ -2430,7 +2419,6 @@
     stored_state_path = os.path.join(server_settings["statedir"],
                                      stored_state_file)
     foreground = server_settings["foreground"]
-    zeroconf = server_settings["zeroconf"]
     
     if debug:
         initlogger(debug, logging.DEBUG)
@@ -2457,9 +2445,6 @@
     global mandos_dbus_service
     mandos_dbus_service = None
     
-    socketfd = None
-    if server_settings["socket"] != "":
-        socketfd = server_settings["socket"]
     tcp_server = MandosServer((server_settings["address"],
                                server_settings["port"]),
                               ClientHandler,
@@ -2469,7 +2454,8 @@
                               gnutls_priority=
                               server_settings["priority"],
                               use_dbus=use_dbus,
-                              socketfd=socketfd)
+                              socketfd=(server_settings["socket"]
+                                        or None))
     if not foreground:
         pidfilename = "/run/mandos.pid"
         if not os.path.isdir("/run/."):
@@ -2545,15 +2531,14 @@
             use_dbus = False
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
-    if zeroconf:
-        protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-        service = AvahiServiceToSyslog(name =
-                                       server_settings["servicename"],
-                                       servicetype = "_mandos._tcp",
-                                       protocol = protocol, bus = bus)
-        if server_settings["interface"]:
-            service.interface = (if_nametoindex
-                                 (str(server_settings["interface"])))
+    protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
+    service = AvahiServiceToSyslog(name =
+                                   server_settings["servicename"],
+                                   servicetype = "_mandos._tcp",
+                                   protocol = protocol, bus = bus)
+    if server_settings["interface"]:
+        service.interface = (if_nametoindex
+                             (str(server_settings["interface"])))
     
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
@@ -2594,7 +2579,7 @@
                            "EOFError:", exc_info=e)
     
     with PGPEngine() as pgp:
-        for client_name, client in clients_data.items():
+        for client_name, client in clients_data.iteritems():
             # Skip removed clients
             if client_name not in client_settings:
                 continue
@@ -2664,7 +2649,7 @@
         clients_data[client_name] = client_settings[client_name]
     
     # Create all client objects
-    for client_name, client in clients_data.items():
+    for client_name, client in clients_data.iteritems():
         tcp_server.clients[client_name] = client_class(
             name = client_name, settings = client,
             server_settings = server_settings)
@@ -2753,8 +2738,7 @@
     
     def cleanup():
         "Cleanup function; run on exit"
-        if zeroconf:
-            service.cleanup()
+        service.cleanup()
         
         multiprocessing.active_children()
         wnull.close()
@@ -2774,8 +2758,8 @@
                 
                 # A list of attributes that can not be pickled
                 # + secret.
-                exclude = { "bus", "changedstate", "secret",
-                            "checker", "server_settings" }
+                exclude = set(("bus", "changedstate", "secret",
+                               "checker", "server_settings"))
                 for name, typ in (inspect.getmembers
                                   (dbus.service.Object)):
                     exclude.add(name)
@@ -2839,8 +2823,7 @@
     tcp_server.server_activate()
     
     # Find out what port we got
-    if zeroconf:
-        service.port = tcp_server.socket.getsockname()[1]
+    service.port = tcp_server.socket.getsockname()[1]
     if use_ipv6:
         logger.info("Now listening on address %r, port %d,"
                     " flowinfo %d, scope_id %d",
@@ -2852,15 +2835,14 @@
     #service.interface = tcp_server.socket.getsockname()[3]
     
     try:
-        if zeroconf:
-            # From the Avahi example code
-            try:
-                service.activate()
-            except dbus.exceptions.DBusException as error:
-                logger.critical("D-Bus Exception", exc_info=error)
-                cleanup()
-                sys.exit(1)
-            # End of Avahi example code
+        # From the Avahi example code
+        try:
+            service.activate()
+        except dbus.exceptions.DBusException as error:
+            logger.critical("D-Bus Exception", exc_info=error)
+            cleanup()
+            sys.exit(1)
+        # End of Avahi example code
         
         gobject.io_add_watch(tcp_server.fileno(), gobject.IO_IN,
                              lambda *args, **kwargs:

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2014-06-22 02:19:30 +0000
+++ mandos-clients.conf.xml	2013-10-20 15:25:09 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2013-10-15">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -177,13 +177,7 @@
 	    <varname>PATH</varname> will be searched.  The default
 	    value for the checker command is <quote><literal
 	    ><command>fping</command> <option>-q</option> <option
-	    >--</option> %%(host)s</literal></quote>.  Note that
-	    <command>mandos-keygen</command>, when generating output
-	    to be inserted into this file, normally looks for an SSH
-	    server on the Mandos client, and, if it find one, outputs
-	    a <option>checker</option> option to check for the
-	    client’s key fingerprint – this is more secure against
-	    spoofing.
+	    >--</option> %%(host)s</literal></quote>.
 	  </para>
 	  <para>
 	    In addition to normal start time expansion, this option

=== modified file 'mandos-ctl'
--- mandos-ctl	2014-07-25 23:16:04 +0000
+++ mandos-ctl	2014-03-01 09:39:25 +0000
@@ -26,10 +26,7 @@
 from __future__ import (division, absolute_import, print_function,
                         unicode_literals)
 
-try:
-    from future_builtins import *
-except ImportError:
-    pass
+from future_builtins import *
 
 import sys
 import argparse
@@ -42,9 +39,6 @@
 
 import dbus
 
-if sys.version_info[0] == 2:
-    str = unicode
-
 locale.setlocale(locale.LC_ALL, "")
 
 tablewords = {
@@ -72,7 +66,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.6.7"
+version = "1.6.4"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""
@@ -157,11 +151,11 @@
     token_duration = Token(re.compile(r"P"), None,
                            frozenset((token_year, token_month,
                                       token_day, token_time,
-                                      token_week)))
+                                      token_week))),
     # Define starting values
     value = datetime.timedelta() # Value so far
     found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
+    followers = frozenset(token_duration,) # Following valid tokens
     s = duration                # String left to parse
     # Loop until end token is found
     while found_token is not token_end:
@@ -236,7 +230,7 @@
         if keyword in ("Timeout", "Interval", "ApprovalDelay",
                        "ApprovalDuration", "ExtendedTimeout"):
             return milliseconds_to_string(value)
-        return str(value)
+        return unicode(value)
     
     # Create format string to print table rows
     format_string = " ".join("{{{key}:{width}}}".format(
@@ -249,10 +243,10 @@
     # Print header line
     print(format_string.format(**tablewords))
     for client in clients:
-        print(format_string.format(**{ key:
+        print(format_string.format(**dict((key,
                                            valuetostring(client[key],
-                                                         key)
-                                       for key in keywords }))
+                                                         key))
+                                          for key in keywords)))
 
 def has_actions(options):
     return any((options.enable,
@@ -316,8 +310,7 @@
     parser.add_argument("--approval-duration",
                         help="Set duration of one client approval")
     parser.add_argument("-H", "--host", help="Set host for client")
-    parser.add_argument("-s", "--secret",
-                        type=argparse.FileType(mode="rb"),
+    parser.add_argument("-s", "--secret", type=file,
                         help="Set password blob (file) for client")
     parser.add_argument("-A", "--approve", action="store_true",
                         help="Approve any current client request")
@@ -372,11 +365,12 @@
     clients={}
     
     if options.all or not options.client:
-        clients = { bus.get_object(busname, path): properties
-                    for path, properties in mandos_clients.items() }
+        clients = dict((bus.get_object(busname, path), properties)
+                       for path, properties in
+                       mandos_clients.iteritems())
     else:
         for name in options.client:
-            for path, client in mandos_clients.items():
+            for path, client in mandos_clients.iteritems():
                 if client["Name"] == name:
                     client_objc = bus.get_object(busname, path)
                     clients[client_objc] = client

=== modified file 'mandos-keygen'
--- mandos-keygen	2014-07-17 03:24:57 +0000
+++ mandos-keygen	2014-03-01 09:51:07 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2014 Teddy Hogeborn
-# Copyright © 2008-2014 Björn Påhlsson
+# Copyright © 2008-2013 Teddy Hogeborn
+# Copyright © 2008-2013 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.6.7"
+VERSION="1.6.4"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=RSA
@@ -33,7 +33,6 @@
 KEYCOMMENT=""
 KEYEXPIRE=0
 FORCE=no
-SSH=yes
 KEYCOMMENT_ORIG="$KEYCOMMENT"
 mode=keygen
 
@@ -42,8 +41,8 @@
 fi
 
 # Parse options
-TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:fS \
-    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force,no-ssh \
+TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:f \
+    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force \
     --name "$0" -- "$@"`
 
 help(){
@@ -86,7 +85,6 @@
                         Encrypt a password from FILE using the key in
                         the key directory.  All options other than
                         --dir and --name are ignored.
-  -S, --no-ssh          Don't get SSH key or set "checker" option.
 EOF
 }
 
@@ -105,7 +103,6 @@
 	-c|--comment) KEYCOMMENT="$2"; shift 2;;
 	-x|--expire) KEYEXPIRE="$2"; shift 2;;
 	-f|--force) FORCE=yes; shift;;
-	-S|--no-ssh) SSH=no; shift;;
 	-v|--version) echo "$0 $VERSION"; exit;;
 	-h|--help) help; exit;;
 	--) shift; break;;
@@ -191,7 +188,7 @@
 trap "
 set +e; \
 test -n \"$SECFILE\" && shred --remove \"$SECFILE\"; \
-shred --remove \"$RINGDIR\"/sec* 2>/dev/null;
+shred --remove \"$RINGDIR\"/sec*;
 test -n \"$BATCHFILE\" && rm --force \"$BATCHFILE\"; \
 rm --recursive --force \"$RINGDIR\";
 tty --quiet && stty echo; \
@@ -277,23 +274,6 @@
 fi
 
 if [ "$mode" = password ]; then
-    
-    # Make SSH be 0 or 1
-    case "$SSH" in
-	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]) SSH=1;;
-	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|*) SSH=0;;
-    esac
-    
-    if [ $SSH -eq 1 ]; then
-	set +e
-	ssh_fingerprint="`ssh-keyscan localhost 2>/dev/null`"
-	if [ $? -ne 0 ]; then
-	    ssh_fingerprint=""
-	fi
-	set -e
-	ssh_fingerprint="${ssh_fingerprint#localhost }"
-    fi
-    
     # Import key into temporary key rings
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always --armor \
@@ -362,10 +342,6 @@
 		/^[^-]/s/^/    /p
 	    }
 	}' < "$SECFILE"
-    if [ -n "$ssh_fingerprint" ]; then
-	echo 'checker = ssh-keyscan %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp="%%(host)s %(ssh_fingerprint)s"'
-	echo "ssh_fingerprint = ${ssh_fingerprint}"
-    fi
 fi
 
 trap - EXIT
@@ -376,5 +352,5 @@
     shred --remove "$SECFILE"
 fi
 # Remove the key rings
-shred --remove "$RINGDIR"/sec* 2>/dev/null
+shred --remove "$RINGDIR"/sec*
 rm --recursive --force "$RINGDIR"

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2014-06-22 02:19:30 +0000
+++ mandos-keygen.xml	2013-10-22 19:24:01 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2013-10-22">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -119,10 +119,7 @@
 	<replaceable>TIME</replaceable></option></arg>
       </group>
       <sbr/>
-      <group>
-	<arg choice="plain"><option>--force</option></arg>
-	<arg choice="plain"><option>-f</option></arg>
-      </group>
+      <arg><option>--force</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -148,10 +145,6 @@
 	<arg choice="plain"><option>-n
 	<replaceable>NAME</replaceable></option></arg>
       </group>
-      <group>
-	<arg choice="plain"><option>--no-ssh</option></arg>
-	<arg choice="plain"><option>-S</option></arg>
-      </group>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -353,22 +346,6 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      <varlistentry>
-	<term><option>--no-ssh</option></term>
-	<term><option>-S</option></term>
-	<listitem>
-	  <para>
-	    When <option>--password</option> or
-	    <option>--passfile</option> is given, this option will
-	    prevent <command>&COMMANDNAME;</command> from calling
-	    <command>ssh-keyscan</command> to get an SSH fingerprint
-	    for this host and, if successful, output suitable config
-	    options to use this fingerprint as a
-	    <option>checker</option> option in the output.  This is
-	    otherwise the default behavior.
-	  </para>
-	</listitem>
-      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -525,9 +502,7 @@
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-client</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>ssh-keyscan</refentrytitle>
-      <manvolnum>1</manvolnum></citerefentry>
+      <manvolnum>8mandos</manvolnum></citerefentry>
     </para>
   </refsect1>
   

=== modified file 'mandos-monitor'
--- mandos-monitor	2014-07-24 02:58:45 +0000
+++ mandos-monitor	2014-03-01 09:39:25 +0000
@@ -60,7 +60,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.6.7"
+version = "1.6.4"
 
 def isoformat_to_datetime(iso):
     "Parse an ISO 8601 date string to a datetime.datetime()"
@@ -161,8 +161,8 @@
                                          self.rejected,
                                          client_interface,
                                          byte_arrays=True))
-        self.logger('Created client {0}'
-                    .format(self.properties["Name"]), level=0)
+        #self.logger('Created client {0}'
+        #            .format(self.properties["Name"]))
     
     def using_timer(self, flag):
         """Call this method with True or False when timer should be
@@ -179,9 +179,6 @@
     
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
-            self.logger('Checker for client {0} (command "{1}")'
-                        ' succeeded'.format(self.properties["Name"],
-                                            command), level=0)
             self.update()
             return
         # Checker failed
@@ -206,10 +203,12 @@
         self.update()
     
     def checker_started(self, command):
-        """Server signals that a checker started."""
-        self.logger('Client {0} started checker "{1}"'
-                    .format(self.properties["Name"],
-                            command), level=0)
+        """Server signals that a checker started. This could be useful
+           to log in the future. """
+        #self.logger('Client {0} started checker "{1}"'
+        #            .format(self.properties["Name"],
+        #                    str(command)))
+        pass
     
     def got_secret(self):
         self.logger('Client {0} received its secret'
@@ -404,7 +403,7 @@
     """This is the entire user interface - the whole screen
     with boxes, lists of client widgets, etc.
     """
-    def __init__(self, max_log_length=1000, log_level=1):
+    def __init__(self, max_log_length=1000):
         DBusGMainLoop(set_as_default=True)
         
         self.screen = urwid.curses_display.Screen()
@@ -448,8 +447,6 @@
         self.log = []
         self.max_log_length = max_log_length
         
-        self.log_level = log_level
-        
         # We keep a reference to the log widget so we can remove it
         # from the ListWalker without it getting destroyed
         self.logbox = ConstrainedListBox(self.log)
@@ -489,18 +486,13 @@
             self.uilist.append(self.logbox)
         self.topwidget = urwid.Pile(self.uilist)
     
-    def log_message(self, message, level=1):
+    def log_message(self, message):
         """Log message formatted with timestamp"""
-        if level < self.log_level:
-            return
         timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw("{0}: {1}".format(timestamp, message),
-                             level=level)
+        self.log_message_raw(timestamp + ": " + message)
     
-    def log_message_raw(self, markup, level=1):
+    def log_message_raw(self, markup):
         """Add a log message to the log buffer."""
-        if level < self.log_level:
-            return
         self.log.append(urwid.Text(markup, wrap=self.log_wrap))
         if (self.max_log_length
             and len(self.log) > self.max_log_length):
@@ -513,8 +505,8 @@
         """Toggle visibility of the log buffer."""
         self.log_visible = not self.log_visible
         self.rebuild()
-        self.log_message("Log visibility changed to: {0}"
-                         .format(self.log_visible), level=0)
+        #self.log_message("Log visibility changed to: "
+        #                 + str(self.log_visible))
     
     def change_log_display(self):
         """Change type of log display.
@@ -525,8 +517,7 @@
             self.log_wrap = "clip"
         for textwidget in self.log:
             textwidget.set_wrap_mode(self.log_wrap)
-        self.log_message("Wrap mode: {0}".format(self.log_wrap),
-                         level=0)
+        #self.log_message("Wrap mode: " + self.log_wrap)
     
     def find_and_remove_client(self, path, name):
         """Find a client by its object path and remove it.
@@ -661,8 +652,7 @@
             elif key == "window resize":
                 self.size = self.screen.get_cols_rows()
                 self.refresh()
-            elif key == "ctrl l":
-                self.screen.clear()
+            elif key == "\f":  # Ctrl-L
                 self.refresh()
             elif key == "l" or key == "D":
                 self.toggle_log_display()
@@ -680,9 +670,7 @@
                                             "?: Help",
                                             "l: Log window toggle",
                                             "TAB: Switch window",
-                                            "w: Wrap (log lines)",
-                                            "v: Toggle verbose log",
-                                            ))))
+                                            "w: Wrap (log)"))))
                 self.log_message_raw(("bold",
                                       "  "
                                       .join(("Clients:",
@@ -701,13 +689,6 @@
                 else:
                     self.topwidget.set_focus(self.logbox)
                 self.refresh()
-            elif key == "v":
-                if self.log_level == 0:
-                    self.log_level = 1
-                    self.log_message("Verbose mode: Off")
-                else:
-                    self.log_level = 0
-                    self.log_message("Verbose mode: On")
             #elif (key == "end" or key == "meta >" or key == "G"
             #      or key == ">"):
             #    pass            # xxx end-of-buffer

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2014-07-14 21:41:08 +0000
+++ mandos-monitor.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2014-07-14">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -129,10 +129,6 @@
 	<entry>Toggle log window line wrap</entry>
       </row>
       <row>
-	<entry>v</entry>
-	<entry>Toggle verbose logging</entry>
-      </row>
-      <row>
 	<entry>Up, Ctrl-P, k</entry>
 	<entry>Move up a line</entry>
       </row>

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2014-06-15 02:48:49 +0000
+++ mandos-options.xml	2013-10-24 20:21:45 +0000
@@ -123,11 +123,4 @@
     implies this option.
   </para>
   
-  <para id="zeroconf">
-    This option controls whether the server will announce its
-    existence using Zeroconf.  Default is to use Zeroconf.  If
-    Zeroconf is not used, a <option>port</option> number or a
-    <option>socket</option> is required.
-  </para>
-  
 </section>

=== modified file 'mandos.conf'
--- mandos.conf	2014-06-15 02:48:49 +0000
+++ mandos.conf	2013-10-22 19:24:01 +0000
@@ -45,9 +45,3 @@
 
 # Whether to run in the foreground
 ;foreground = False
-
-# File descriptor number to use for network socket
-;socket = 
-
-# Whether to use ZeroConf; if false, requires port or socket
-;zeroconf = True

=== modified file 'mandos.lsm'
--- mandos.lsm	2014-07-17 03:24:57 +0000
+++ mandos.lsm	2014-02-16 14:22:03 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.6.7
-Entered-date:	2014-07-17
+Version:	1.6.4
+Entered-date:	2014-02-16
 Description:	The Mandos system allows computers to have encrypted
 		root file systems and at the same time be capable of
 		remote and/or unattended reboots.
@@ -11,13 +11,13 @@
 		belorn@recompile.se (Björn Påhlsson)
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
-Primary-site:	http://www.recompile.se/mandos
-		161K mandos_1.6.7.orig.tar.gz
-Alternate-site:	ftp://ftp.recompile.se/pub/mandos
-		161K mandos_1.6.7.orig.tar.gz
+Primary-site: http://www.recompile.se/mandos
+	      158K mandos_1.6.4.orig.tar.gz
+Alternate-site: ftp://ftp.recompile.se/pub/mandos
+		158K mandos_1.6.4.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 		various other libraries.  While made for Debian
 		GNU/Linux, it is probably portable to other
-		distributions, but not other Unixes.
-Copying-policy:	GNU General Public License version 3.0 or later
+		distributions, but not other Unixes. 
+Copying-policy: GNU General Public License version 3.0 or later
 End

=== modified file 'mandos.xml'
--- mandos.xml	2014-06-15 02:48:49 +0000
+++ mandos.xml	2013-10-26 19:05:21 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2014-06-15">
+<!ENTITY TIMESTAMP "2013-10-26">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -106,8 +106,6 @@
       <replaceable>FD</replaceable></option></arg>
       <sbr/>
       <arg><option>--foreground</option></arg>
-      <sbr/>
-      <arg><option>--no-zeroconf</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -325,13 +323,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>--no-zeroconf</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="zeroconf"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2014-07-16 01:41:23 +0000
+++ plugin-runner.c	2014-03-23 22:12:57 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2013 Teddy Hogeborn
+ * Copyright © 2008-2013 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -23,17 +23,18 @@
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), getline(),
-				   O_CLOEXEC, pipe2() */
+				   O_CLOEXEC */
 #include <stddef.h>		/* size_t, NULL */
 #include <stdlib.h>		/* malloc(), exit(), EXIT_SUCCESS,
 				   realloc() */
 #include <stdbool.h>		/* bool, true, false */
 #include <stdio.h>		/* fileno(), fprintf(),
 				   stderr, STDOUT_FILENO, fclose() */
-#include <sys/types.h>	        /* fstat(), struct stat, waitpid(),
-				   WIFEXITED(), WEXITSTATUS(), wait(),
-				   pid_t, uid_t, gid_t, getuid(),
-				   getgid() */
+#include <sys/types.h>	        /* DIR, fdopendir(), fstat(), struct
+				   stat, waitpid(), WIFEXITED(),
+				   WEXITSTATUS(), wait(), pid_t,
+				   uid_t, gid_t, getuid(), getgid(),
+				   dirfd() */
 #include <sys/select.h>		/* fd_set, select(), FD_ZERO(),
 				   FD_SET(), FD_ISSET(), FD_CLR */
 #include <sys/wait.h>		/* wait(), waitpid(), WIFEXITED(),
@@ -41,17 +42,17 @@
 				   WCOREDUMP() */
 #include <sys/stat.h>		/* struct stat, fstat(), S_ISREG() */
 #include <iso646.h>		/* and, or, not */
-#include <dirent.h>		/* struct dirent, scandirat() */
+#include <dirent.h>		/* DIR, struct dirent, fdopendir(),
+				   readdir(), closedir(), dirfd() */
 #include <unistd.h>		/* fcntl(), F_GETFD, F_SETFD,
 				   FD_CLOEXEC, write(), STDOUT_FILENO,
 				   struct stat, fstat(), close(),
 				   setgid(), setuid(), S_ISREG(),
-				   faccessat() pipe2(), fork(),
+				   faccessat() pipe(), fork(),
 				   _exit(), dup2(), fexecve(), read()
 				*/
 #include <fcntl.h>		/* fcntl(), F_GETFD, F_SETFD,
-				   FD_CLOEXEC, openat(), scandirat(),
-				   pipe2() */
+				   FD_CLOEXEC, openat() */
 #include <string.h>		/* strsep, strlen(), strsignal(),
 				   strcmp(), strncmp() */
 #include <errno.h>		/* errno */
@@ -71,7 +72,6 @@
 				   EX_CONFIG, EX_UNAVAILABLE, EX_OK */
 #include <errno.h> 		/* errno */
 #include <error.h>		/* error() */
-#include <fnmatch.h>		/* fnmatch() */
 
 #define BUFFER_SIZE 256
 
@@ -240,7 +240,6 @@
   return add_to_char_array(def, &(p->environ), &(p->envc));
 }
 
-#ifndef O_CLOEXEC
 /*
  * Based on the example in the GNU LibC manual chapter 13.13 "File
  * Descriptor Flags".
@@ -257,7 +256,6 @@
   return (int)TEMP_FAILURE_RETRY(fcntl(fd, F_SETFD,
 				       ret | FD_CLOEXEC));
 }
-#endif	/* not O_CLOEXEC */
 
 
 /* Mark processes as completed when they exit, and save their exit
@@ -349,7 +347,9 @@
   char *plugindir = NULL;
   char *argfile = NULL;
   FILE *conffp;
-  struct dirent **direntries = NULL;
+  size_t d_name_len;
+  DIR *dir = NULL;
+  struct dirent *dirst;
   struct stat st;
   fd_set rfds_all;
   int ret, maxfd = 0;
@@ -363,7 +363,7 @@
 				      .sa_flags = SA_NOCLDSTOP };
   char **custom_argv = NULL;
   int custom_argc = 0;
-  int dir_fd = -1;
+  int dir_fd;
   
   /* Establish a signal handler */
   sigemptyset(&sigchld_action.sa_mask);
@@ -829,104 +829,153 @@
     ret = set_cloexec_flag(dir_fd);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
+      TEMP_FAILURE_RETRY(close(dir_fd));
       exitstatus = EX_OSERR;
       goto fallback;
     }
 #endif	/* O_CLOEXEC */
-  }
-  
-  int good_name(const struct dirent * const dirent){
-    const char * const patterns[] = { ".*", "#*#", "*~", "*.dpkg-new",
-				      "*.dpkg-old", "*.dpkg-bak",
-				      "*.dpkg-divert", NULL };
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-    for(const char **pat = (const char **)patterns;
-	*pat != NULL; pat++){
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
-      if(fnmatch(*pat, dirent->d_name, FNM_FILE_NAME | FNM_PERIOD)
-	 != FNM_NOMATCH){
-	if(debug){
-	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
-		    " matching pattern %s\n", dirent->d_name, *pat);
-	}
-	return 0;
-      }
+    
+    dir = fdopendir(dir_fd);
+    if(dir == NULL){
+      error(0, errno, "Could not open plugin dir");
+      TEMP_FAILURE_RETRY(close(dir_fd));
+      exitstatus = EX_OSERR;
+      goto fallback;
     }
-    return 1;
-  }
-  
-#ifdef __GLIBC__
-#if __GLIBC_PREREQ(2, 15)
-  int numplugins = scandirat(dir_fd, ".", &direntries, good_name,
-			     alphasort);
-#else  /* not __GLIBC_PREREQ(2, 15) */
-  int numplugins = scandir(plugindir != NULL ? plugindir : PDIR,
-			   &direntries, good_name, alphasort);
-#endif	/* not __GLIBC_PREREQ(2, 15) */
-#else	/* not __GLIBC__ */
-  int numplugins = scandir(plugindir != NULL ? plugindir : PDIR,
-			   &direntries, good_name, alphasort);
-#endif	/* not __GLIBC__ */
-  if(numplugins == -1){
-    error(0, errno, "Could not scan plugin dir");
-    direntries = NULL;
-    exitstatus = EX_OSERR;
-    goto fallback;
   }
   
   FD_ZERO(&rfds_all);
   
   /* Read and execute any executable in the plugin directory*/
-  for(int i = 0; i < numplugins; i++){
-    
-    int plugin_fd = openat(dir_fd, direntries[i]->d_name, O_RDONLY);
+  while(true){
+    do {
+      dirst = readdir(dir);
+    } while(dirst == NULL and errno == EINTR);
+    
+    /* All directory entries have been processed */
+    if(dirst == NULL){
+      if(errno == EBADF){
+	error(0, errno, "readdir");
+	exitstatus = EX_IOERR;
+	goto fallback;
+      }
+      break;
+    }
+    
+    d_name_len = strlen(dirst->d_name);
+    
+    /* Ignore dotfiles, backup files and other junk */
+    {
+      bool bad_name = false;
+      
+      const char * const bad_prefixes[] = { ".", "#", NULL };
+      
+      const char * const bad_suffixes[] = { "~", "#", ".dpkg-new",
+					   ".dpkg-old",
+					   ".dpkg-bak",
+					   ".dpkg-divert", NULL };
+#ifdef __GNUC__
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wcast-qual"
+#endif
+      for(const char **pre = (const char **)bad_prefixes;
+	  *pre != NULL; pre++){
+#ifdef __GNUC__
+#pragma GCC diagnostic pop
+#endif
+	size_t pre_len = strlen(*pre);
+	if((d_name_len >= pre_len)
+	   and strncmp((dirst->d_name), *pre, pre_len) == 0){
+	  if(debug){
+	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
+		    " with bad prefix %s\n", dirst->d_name, *pre);
+	  }
+	  bad_name = true;
+	  break;
+	}
+      }
+      if(bad_name){
+	continue;
+      }
+#ifdef __GNUC__
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wcast-qual"
+#endif
+      for(const char **suf = (const char **)bad_suffixes;
+	  *suf != NULL; suf++){
+#ifdef __GNUC__
+#pragma GCC diagnostic pop
+#endif
+	size_t suf_len = strlen(*suf);
+	if((d_name_len >= suf_len)
+	   and (strcmp((dirst->d_name) + d_name_len-suf_len, *suf)
+		== 0)){
+	  if(debug){
+	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
+		    " with bad suffix %s\n", dirst->d_name, *suf);
+	  }
+	  bad_name = true;
+	  break;
+	}
+      }
+      
+      if(bad_name){
+	continue;
+      }
+    }
+    
+    int plugin_fd = openat(dir_fd, dirst->d_name, O_RDONLY |
+#ifdef O_CLOEXEC
+			    O_CLOEXEC
+#else  /* not O_CLOEXEC */
+			    0
+#endif	/* not O_CLOEXEC */
+			    );
     if(plugin_fd == -1){
       error(0, errno, "Could not open plugin");
-      free(direntries[i]);
-      continue;
-    }
+      continue;
+    }
+#ifndef O_CLOEXEC
+  /* Set the FD_CLOEXEC flag on the plugin FD */
+    ret = set_cloexec_flag(plugin_fd);
+    if(ret < 0){
+      error(0, errno, "set_cloexec_flag");
+      TEMP_FAILURE_RETRY(close(plugin_fd));
+      continue;
+    }
+#endif	/* O_CLOEXEC */
     ret = (int)TEMP_FAILURE_RETRY(fstat(plugin_fd, &st));
     if(ret == -1){
       error(0, errno, "stat");
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     
     /* Ignore non-executable files */
     if(not S_ISREG(st.st_mode)
-       or (TEMP_FAILURE_RETRY(faccessat(dir_fd, direntries[i]->d_name,
-					X_OK, 0)) != 0)){
+       or (TEMP_FAILURE_RETRY(faccessat(dir_fd, dirst->d_name, X_OK,
+					0)) != 0)){
       if(debug){
 	fprintf(stderr, "Ignoring plugin dir entry \"%s/%s\""
 		" with bad type or mode\n",
-		plugindir != NULL ? plugindir : PDIR,
-		direntries[i]->d_name);
+		plugindir != NULL ? plugindir : PDIR, dirst->d_name);
       }
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     
-    plugin *p = getplugin(direntries[i]->d_name);
+    plugin *p = getplugin(dirst->d_name);
     if(p == NULL){
       error(0, errno, "getplugin");
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     if(p->disabled){
       if(debug){
 	fprintf(stderr, "Ignoring disabled plugin \"%s\"\n",
-		direntries[i]->d_name);
+		dirst->d_name);
       }
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     {
@@ -957,47 +1006,25 @@
     }
     
     int pipefd[2];
-#ifndef O_CLOEXEC
     ret = (int)TEMP_FAILURE_RETRY(pipe(pipefd));
-#else  /* O_CLOEXEC */
-    ret = (int)TEMP_FAILURE_RETRY(pipe2(pipefd, O_CLOEXEC));
-#endif	/* O_CLOEXEC */
     if(ret == -1){
       error(0, errno, "pipe");
       exitstatus = EX_OSERR;
-      free(direntries[i]);
-      goto fallback;
-    }
-    if(pipefd[0] >= FD_SETSIZE){
-      fprintf(stderr, "pipe()[0] (%d) >= FD_SETSIZE (%d)", pipefd[0],
-	      FD_SETSIZE);
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
-      exitstatus = EX_OSERR;
-      free(direntries[i]);
-      goto fallback;
-    }
-#ifndef O_CLOEXEC
+      goto fallback;
+    }
     /* Ask OS to automatic close the pipe on exec */
     ret = set_cloexec_flag(pipefd[0]);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     ret = set_cloexec_flag(pipefd[1]);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
-#endif	/* not O_CLOEXEC */
     /* Block SIGCHLD until process is safely in process list */
     ret = (int)TEMP_FAILURE_RETRY(sigprocmask(SIG_BLOCK,
 					      &sigchld_action.sa_mask,
@@ -1005,7 +1032,6 @@
     if(ret < 0){
       error(0, errno, "sigprocmask");
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     /* Starting a new process to be watched */
@@ -1015,12 +1041,7 @@
     } while(pid == -1 and errno == EINTR);
     if(pid == -1){
       error(0, errno, "fork");
-      TEMP_FAILURE_RETRY(sigprocmask(SIG_UNBLOCK,
-				     &sigchld_action.sa_mask, NULL));
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     if(pid == 0){
@@ -1042,11 +1063,15 @@
 	_exit(EX_OSERR);
       }
       
+      if(dirfd(dir) < 0){
+	/* If dir has no file descriptor, we could not set FD_CLOEXEC
+	   above and must now close it manually here. */
+	closedir(dir);
+      }
       if(fexecve(plugin_fd, p->argv,
 		(p->environ[0] != NULL) ? p->environ : environ) < 0){
 	error(0, errno, "fexecve for %s/%s",
-	      plugindir != NULL ? plugindir : PDIR,
-	      direntries[i]->d_name);
+	      plugindir != NULL ? plugindir : PDIR, dirst->d_name);
 	_exit(EX_OSERR);
       }
       /* no return */
@@ -1055,7 +1080,7 @@
     TEMP_FAILURE_RETRY(close(pipefd[1])); /* Close unused write end of
 					     pipe */
     TEMP_FAILURE_RETRY(close(plugin_fd));
-    plugin *new_plugin = getplugin(direntries[i]->d_name);
+    plugin *new_plugin = getplugin(dirst->d_name);
     if(new_plugin == NULL){
       error(0, errno, "getplugin");
       ret = (int)(TEMP_FAILURE_RETRY
@@ -1065,10 +1090,8 @@
         error(0, errno, "sigprocmask");
       }
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
-    free(direntries[i]);
     
     new_plugin->pid = pid;
     new_plugin->fd = pipefd[0];
@@ -1104,10 +1127,8 @@
     }
   }
   
-  free(direntries);
-  direntries = NULL;
-  TEMP_FAILURE_RETRY(close(dir_fd));
-  dir_fd = -1;
+  TEMP_FAILURE_RETRY(closedir(dir));
+  dir = NULL;
   free_plugin(getplugin(NULL));
   
   for(plugin *p = plugin_list; p != NULL; p = p->next){
@@ -1307,10 +1328,8 @@
     free(custom_argv);
   }
   
-  free(direntries);
-  
-  if(dir_fd != -1){
-    TEMP_FAILURE_RETRY(close(dir_fd));
+  if(dir != NULL){
+    closedir(dir);
   }
   
   /* Kill the processes */

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2014-03-29 02:38:15 +0000
+++ plugins.d/askpass-fifo.c	2014-03-10 07:04:09 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2014-07-15 23:52:00 +0000
+++ plugins.d/mandos-client.c	2014-03-23 19:55:18 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2013 Teddy Hogeborn
+ * Copyright © 2008-2013 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -32,15 +32,15 @@
 /* Needed by GPGME, specifically gpgme_data_seek() */
 #ifndef _LARGEFILE_SOURCE
 #define _LARGEFILE_SOURCE
-#endif	/* not _LARGEFILE_SOURCE */
+#endif
 #ifndef _FILE_OFFSET_BITS
 #define _FILE_OFFSET_BITS 64
-#endif	/* not _FILE_OFFSET_BITS */
+#endif
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
 
 #include <stdio.h>		/* fprintf(), stderr, fwrite(),
-				   stdout, ferror() */
+				   stdout, ferror(), remove() */
 #include <stdint.h> 		/* uint16_t, uint32_t, intptr_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <stdlib.h> 		/* free(), EXIT_SUCCESS, srand(),
@@ -57,7 +57,7 @@
 #include <sys/socket.h>		/* socket(), struct sockaddr_in6,
 				   inet_pton(), connect(),
 				   getnameinfo() */
-#include <fcntl.h>		/* open(), unlinkat() */
+#include <fcntl.h>		/* open() */
 #include <dirent.h>		/* opendir(), struct dirent, readdir()
 				 */
 #include <inttypes.h>		/* PRIu16, PRIdMAX, intmax_t,
@@ -73,8 +73,7 @@
 				*/
 #include <unistd.h>		/* close(), SEEK_SET, off_t, write(),
 				   getuid(), getgid(), seteuid(),
-				   setgid(), pause(), _exit(),
-				   unlinkat() */
+				   setgid(), pause(), _exit() */
 #include <arpa/inet.h>		/* inet_pton(), htons() */
 #include <iso646.h>		/* not, or, and */
 #include <argp.h>		/* struct argp_option, error_t, struct
@@ -137,12 +136,11 @@
 
 bool debug = false;
 static const char mandos_protocol_version[] = "1";
-const char *argp_program_version = "mandos-client " VERSION;
-const char *argp_program_bug_address = "<mandos@recompile.se>";
+const char * argp_program_version = "mandos-client " VERSION;
+const char * argp_program_bug_address = "<mandos@recompile.se>";
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
 const char *hookdir = HOOKDIR;
-int hookdir_fd = -1;
 uid_t uid = 65534;
 gid_t gid = 65534;
 
@@ -234,21 +232,11 @@
 			  .af = af };
   if(new_server->ip == NULL){
     perror_plus("strdup");
-    free(new_server);
     return false;
   }
   ret = clock_gettime(CLOCK_MONOTONIC, &(new_server->last_seen));
   if(ret == -1){
     perror_plus("clock_gettime");
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-    free((char *)(new_server->ip));
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
-    free(new_server);
     return false;
   }
   /* Special case of first server */
@@ -1076,7 +1064,6 @@
      timed out */
   
   if(quit_now){
-    avahi_s_service_resolver_free(r);
     return;
   }
   
@@ -1348,7 +1335,7 @@
   sret = strspn(direntry->d_name, "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
 		"abcdefghijklmnopqrstuvwxyz"
 		"0123456789"
-		"_.-");
+		"_-");
   if((direntry->d_name)[sret] != '\0'){
     /* Contains non-allowed characters */
     if(debug){
@@ -1358,7 +1345,14 @@
     return 0;
   }
   
-  ret = fstatat(hookdir_fd, direntry->d_name, &st, 0);
+  char *fullname = NULL;
+  ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
+  if(ret < 0){
+    perror_plus("asprintf");
+    return 0;
+  }
+  
+  ret = stat(fullname, &st);
   if(ret == -1){
     if(debug){
       perror_plus("Could not stat hook");
@@ -1469,6 +1463,7 @@
   error_t ret_errno = 0;
   if(seteuid(0) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
@@ -1485,6 +1480,7 @@
   }
   if(setuid(0) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
@@ -1497,6 +1493,7 @@
   error_t ret_errno = 0;
   if(seteuid(uid) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
@@ -1509,6 +1506,7 @@
   error_t ret_errno = 0;
   if(setuid(uid) == -1){
     ret_errno = errno;
+    perror_plus("setuid");
   }
   errno = old_errno;
   return ret_errno;
@@ -1517,179 +1515,151 @@
 __attribute__((nonnull))
 void run_network_hooks(const char *mode, const char *interface,
 		       const float delay){
-  struct dirent **direntries = NULL;
-  if(hookdir_fd == -1){
-    hookdir_fd = open(hookdir, O_RDONLY);
-    if(hookdir_fd == -1){
-      if(errno == ENOENT){
-	if(debug){
-	  fprintf_plus(stderr, "Network hook directory \"%s\" not"
-		       " found\n", hookdir);
-	}
-      } else {
-	perror_plus("open");
-      }
-      return;
-    }
-  }
-#ifdef __GLIBC__
-#if __GLIBC_PREREQ(2, 15)
-  int numhooks = scandirat(hookdir_fd, ".", &direntries,
-			   runnable_hook, alphasort);
-#else  /* not __GLIBC_PREREQ(2, 15) */
-  int numhooks = scandir(hookdir, &direntries, runnable_hook,
-			 alphasort);
-#endif	/* not __GLIBC_PREREQ(2, 15) */
-#else	/* not __GLIBC__ */
-  int numhooks = scandir(hookdir, &direntries, runnable_hook,
-			 alphasort);
-#endif	/* not __GLIBC__ */
+  struct dirent **direntries;
+  int numhooks = scandir(hookdir, &direntries, runnable_hook,
+			 alphasort);
   if(numhooks == -1){
-    perror_plus("scandir");
-    return;
-  }
-  struct dirent *direntry;
-  int ret;
-  int devnull = open("/dev/null", O_RDONLY);
-  for(int i = 0; i < numhooks; i++){
-    direntry = direntries[i];
-    if(debug){
-      fprintf_plus(stderr, "Running network hook \"%s\"\n",
-		   direntry->d_name);
+    if(errno == ENOENT){
+      if(debug){
+	fprintf_plus(stderr, "Network hook directory \"%s\" not"
+		     " found\n", hookdir);
+      }
+    } else {
+      perror_plus("scandir");
     }
-    pid_t hook_pid = fork();
-    if(hook_pid == 0){
-      /* Child */
-      /* Raise privileges */
-      errno = raise_privileges_permanently();
-      if(errno != 0){
-	perror_plus("Failed to raise privileges");
-	_exit(EX_NOPERM);
-      }
-      /* Set group */
-      errno = 0;
-      ret = setgid(0);
-      if(ret == -1){
-	perror_plus("setgid");
-	_exit(EX_NOPERM);
-      }
-      /* Reset supplementary groups */
-      errno = 0;
-      ret = setgroups(0, NULL);
-      if(ret == -1){
-	perror_plus("setgroups");
-	_exit(EX_NOPERM);
-      }
-      ret = dup2(devnull, STDIN_FILENO);
-      if(ret == -1){
-	perror_plus("dup2(devnull, STDIN_FILENO)");
-	_exit(EX_OSERR);
-      }
-      ret = close(devnull);
-      if(ret == -1){
-	perror_plus("close");
-	_exit(EX_OSERR);
-      }
-      ret = dup2(STDERR_FILENO, STDOUT_FILENO);
-      if(ret == -1){
-	perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("DEVICE", interface, 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("VERBOSITY", debug ? "1" : "0", 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("MODE", mode, 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      char *delaystring;
-      ret = asprintf(&delaystring, "%f", (double)delay);
-      if(ret == -1){
+  } else {
+    struct dirent *direntry;
+    int ret;
+    int devnull = open("/dev/null", O_RDONLY);
+    for(int i = 0; i < numhooks; i++){
+      direntry = direntries[i];
+      char *fullname = NULL;
+      ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
+      if(ret < 0){
 	perror_plus("asprintf");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("DELAY", delaystring, 1);
-      if(ret == -1){
+	continue;
+      }
+      if(debug){
+	fprintf_plus(stderr, "Running network hook \"%s\"\n",
+		     direntry->d_name);
+      }
+      pid_t hook_pid = fork();
+      if(hook_pid == 0){
+	/* Child */
+	/* Raise privileges */
+	if(raise_privileges_permanently() != 0){
+	  perror_plus("Failed to raise privileges");
+	  _exit(EX_NOPERM);
+	}
+	/* Set group */
+	errno = 0;
+	ret = setgid(0);
+	if(ret == -1){
+	  perror_plus("setgid");
+	  _exit(EX_NOPERM);
+	}
+	/* Reset supplementary groups */
+	errno = 0;
+	ret = setgroups(0, NULL);
+	if(ret == -1){
+	  perror_plus("setgroups");
+	  _exit(EX_NOPERM);
+	}
+	ret = dup2(devnull, STDIN_FILENO);
+	if(ret == -1){
+	  perror_plus("dup2(devnull, STDIN_FILENO)");
+	  _exit(EX_OSERR);
+	}
+	ret = close(devnull);
+	if(ret == -1){
+	  perror_plus("close");
+	  _exit(EX_OSERR);
+	}
+	ret = dup2(STDERR_FILENO, STDOUT_FILENO);
+	if(ret == -1){
+	  perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("DEVICE", interface, 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("VERBOSITY", debug ? "1" : "0", 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("MODE", mode, 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	char *delaystring;
+	ret = asprintf(&delaystring, "%f", (double)delay);
+	if(ret == -1){
+	  perror_plus("asprintf");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("DELAY", delaystring, 1);
+	if(ret == -1){
+	  free(delaystring);
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
 	free(delaystring);
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      free(delaystring);
-      if(connect_to != NULL){
-	ret = setenv("CONNECT", connect_to, 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  _exit(EX_OSERR);
-	}
-      }
-      int hook_fd = openat(hookdir_fd, direntry->d_name, O_RDONLY);
-      if(hook_fd == -1){
-	perror_plus("openat");
-	_exit(EXIT_FAILURE);
-      }
-      if((int)TEMP_FAILURE_RETRY(close(hookdir_fd)) == -1){
-	perror_plus("close");
-	_exit(EXIT_FAILURE);
-      }
-      if(fexecve(hook_fd, (char *const []){ direntry->d_name, NULL },
-		 environ) == -1){
-	perror_plus("fexecve");
-	_exit(EXIT_FAILURE);
-      }
-    } else {
-      int status;
-      if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
-	perror_plus("waitpid");
-	free(direntry);
-	continue;
-      }
-      if(WIFEXITED(status)){
-	if(WEXITSTATUS(status) != 0){
-	  fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
-		       " with status %d\n", direntry->d_name,
-		       WEXITSTATUS(status));
-	  free(direntry);
-	  continue;
-	}
-      } else if(WIFSIGNALED(status)){
-	fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
-		     " signal %d\n", direntry->d_name,
-		     WTERMSIG(status));
-	free(direntry);
-	continue;
+	if(connect_to != NULL){
+	  ret = setenv("CONNECT", connect_to, 1);
+	  if(ret == -1){
+	    perror_plus("setenv");
+	    _exit(EX_OSERR);
+	  }
+	}
+	if(execl(fullname, direntry->d_name, mode, NULL) == -1){
+	  perror_plus("execl");
+	  _exit(EXIT_FAILURE);
+	}
       } else {
-	fprintf_plus(stderr, "Warning: network hook \"%s\""
-		     " crashed\n", direntry->d_name);
-	free(direntry);
-	continue;
-      }
-    }
-    if(debug){
-      fprintf_plus(stderr, "Network hook \"%s\" ran successfully\n",
-		   direntry->d_name);
-    }
-    free(direntry);
-  }
-  free(direntries);
-  if((int)TEMP_FAILURE_RETRY(close(hookdir_fd)) == -1){
-    perror_plus("close");
-  } else {
-    hookdir_fd = -1;
-  }
-  close(devnull);
+	int status;
+	if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
+	  perror_plus("waitpid");
+	  free(fullname);
+	  continue;
+	}
+	if(WIFEXITED(status)){
+	  if(WEXITSTATUS(status) != 0){
+	    fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
+			 " with status %d\n", direntry->d_name,
+			 WEXITSTATUS(status));
+	    free(fullname);
+	    continue;
+	  }
+	} else if(WIFSIGNALED(status)){
+	  fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
+		       " signal %d\n", direntry->d_name,
+		       WTERMSIG(status));
+	  free(fullname);
+	  continue;
+	} else {
+	  fprintf_plus(stderr, "Warning: network hook \"%s\""
+		       " crashed\n", direntry->d_name);
+	  free(fullname);
+	  continue;
+	}
+      }
+      free(fullname);
+      if(debug){
+	fprintf_plus(stderr, "Network hook \"%s\" ran successfully\n",
+		     direntry->d_name);
+      }
+    }
+    close(devnull);
+  }
 }
 
 __attribute__((nonnull, warn_unused_result))
@@ -1745,14 +1715,12 @@
     
     /* Raise privileges */
     ret_errno = raise_privileges();
+    bool restore_loglevel = false;
     if(ret_errno != 0){
-      errno = ret_errno;
       perror_plus("Failed to raise privileges");
     }
-    
 #ifdef __linux__
     int ret_linux;
-    bool restore_loglevel = false;
     if(ret_errno == 0){
       /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
 	 messages about the network interface to mess up the prompt */
@@ -1856,10 +1824,8 @@
     /* Raise privileges */
     ret_errno = raise_privileges();
     if(ret_errno != 0){
-      errno = ret_errno;
       perror_plus("Failed to raise privileges");
     }
-    
     int ret_setflags = ioctl(sd, SIOCSIFFLAGS, &network);
     ioctl_errno = errno;
     
@@ -2269,7 +2235,7 @@
   
   /* If no interfaces were specified, make a list */
   if(mc.interfaces == NULL){
-    struct dirent **direntries = NULL;
+    struct dirent **direntries;
     /* Look for any good interfaces */
     ret = scandir(sys_class_net, &direntries, good_interface,
 		  alphasort);
@@ -2281,20 +2247,16 @@
 	if(ret_errno != 0){
 	  errno = ret_errno;
 	  perror_plus("argz_add");
-	  free(direntries[i]);
 	  continue;
 	}
 	if(debug){
 	  fprintf_plus(stderr, "Will use interface \"%s\"\n",
 		       direntries[i]->d_name);
 	}
-	free(direntries[i]);
       }
       free(direntries);
     } else {
-      if(ret == 0){
-	free(direntries);
-      }
+      free(direntries);
       fprintf_plus(stderr, "Could not find a network interface\n");
       exitcode = EXIT_FAILURE;
       goto end;
@@ -2522,7 +2484,7 @@
   if(debug){
     fprintf_plus(stderr, "Starting Avahi loop search\n");
   }
-  
+
   ret = avahi_loop_with_timeout(simple_poll,
 				(int)(retry_interval * 1000), &mc);
   if(debug){
@@ -2564,14 +2526,6 @@
     mc.current_server->prev->next = NULL;
     while(mc.current_server != NULL){
       server *next = mc.current_server->next;
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-      free((char *)(mc.current_server->ip));
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
       free(mc.current_server);
       mc.current_server = next;
     }
@@ -2581,7 +2535,6 @@
   {
     ret_errno = raise_privileges();
     if(ret_errno != 0){
-      errno = ret_errno;
       perror_plus("Failed to raise privileges");
     } else {
       
@@ -2607,10 +2560,8 @@
 	}
       }
     }
-    
     ret_errno = lower_privileges_permanently();
     if(ret_errno != 0){
-      errno = ret_errno;
       perror_plus("Failed to lower privileges permanently");
     }
   }
@@ -2621,45 +2572,36 @@
   /* Removes the GPGME temp directory and all files inside */
   if(tempdir != NULL){
     struct dirent **direntries = NULL;
-    int tempdir_fd = (int)TEMP_FAILURE_RETRY(open(tempdir, O_RDONLY |
-						  O_NOFOLLOW));
-    if(tempdir_fd == -1){
-      perror_plus("open");
-    } else {
-#ifdef __GLIBC__
-#if __GLIBC_PREREQ(2, 15)
-      int numentries = scandirat(tempdir_fd, ".", &direntries,
-				 notdotentries, alphasort);
-#else  /* not __GLIBC_PREREQ(2, 15) */
-      int numentries = scandir(tempdir, &direntries, notdotentries,
-			       alphasort);
-#endif	/* not __GLIBC_PREREQ(2, 15) */
-#else	/* not __GLIBC__ */
-      int numentries = scandir(tempdir, &direntries, notdotentries,
-			       alphasort);
-#endif	/* not __GLIBC__ */
-      if(numentries >= 0){
-	for(int i = 0; i < numentries; i++){
-	  ret = unlinkat(tempdir_fd, direntries[i]->d_name, 0);
-	  if(ret == -1){
-	    fprintf_plus(stderr, "unlinkat(open(\"%s\", O_RDONLY),"
-			 " \"%s\", 0): %s\n", tempdir,
-			 direntries[i]->d_name, strerror(errno));
-	  }
-	  free(direntries[i]);
-	}
-	
-	/* need to clean even if 0 because man page doesn't specify */
-	free(direntries);
-	if(numentries == -1){
-	  perror_plus("scandir");
-	}
-	ret = rmdir(tempdir);
-	if(ret == -1 and errno != ENOENT){
-	  perror_plus("rmdir");
-	}
+    struct dirent *direntry = NULL;
+    int numentries = scandir(tempdir, &direntries, notdotentries,
+			     alphasort);
+    if(numentries > 0){
+      for(int i = 0; i < numentries; i++){
+	direntry = direntries[i];
+	char *fullname = NULL;
+	ret = asprintf(&fullname, "%s/%s", tempdir,
+		       direntry->d_name);
+	if(ret < 0){
+	  perror_plus("asprintf");
+	  continue;
+	}
+	ret = remove(fullname);
+	if(ret == -1){
+	  fprintf_plus(stderr, "remove(\"%s\"): %s\n", fullname,
+		       strerror(errno));
+	}
+	free(fullname);
       }
-      TEMP_FAILURE_RETRY(close(tempdir_fd));
+    }
+
+    /* need to clean even if 0 because man page doesn't specify */
+    free(direntries);
+    if(numentries == -1){
+      perror_plus("scandir");
+    }
+    ret = rmdir(tempdir);
+    if(ret == -1 and errno != ENOENT){
+      perror_plus("rmdir");
     }
   }
   

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2014-06-22 02:19:30 +0000
+++ plugins.d/mandos-client.xml	2014-03-06 02:26:04 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2014-03-05">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -748,9 +748,8 @@
     <para>
       It will also help if the checker program on the server is
       configured to request something from the client which can not be
-      spoofed by someone else on the network, like SSH server key
-      fingerprints, and unlike unencrypted <acronym>ICMP</acronym>
-      echo (<quote>ping</quote>) replies.
+      spoofed by someone else on the network, unlike unencrypted
+      <acronym>ICMP</acronym> echo (<quote>ping</quote>) replies.
     </para>
     <para>
       <emphasis>Note</emphasis>: This makes it completely insecure to

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2014-03-29 02:38:15 +0000
+++ plugins.d/password-prompt.c	2014-03-10 07:04:09 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2013 Teddy Hogeborn
+ * Copyright © 2008-2013 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2014-03-29 02:38:15 +0000
+++ plugins.d/plymouth.c	2014-03-10 07:04:09 +0000
@@ -2,8 +2,8 @@
 /*
  * Plymouth - Read a password from Plymouth and output it
  * 
- * Copyright © 2010-2014 Teddy Hogeborn
- * Copyright © 2010-2014 Björn Påhlsson
+ * Copyright © 2010-2013 Teddy Hogeborn
+ * Copyright © 2010-2013 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2014-03-29 02:38:15 +0000
+++ plugins.d/splashy.c	2014-03-10 07:04:09 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2014-03-29 02:38:15 +0000
+++ plugins.d/usplash.c	2014-03-10 07:04:09 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

